<?php
/*
+---------------------------------------------------------------+
|  e107 website system menu
|  /menus/unkie_menu.php
|
|  Mark Pustjens 2003-2004
|  http://unkie.org
|  mark@unkie.org
|
|  Released under the terms and conditions of the
|  GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/

function makemenuurl($strdepth, $linkadd, $submenu, $linkname, $specialcase) {
  $currenturl = $_SERVER["REQUEST_URI"];

  if ($specialcase >= 1) {
    preg_match("/(.*=)(.*)/", $currenturl, $m);
    $a = $m[1];
    $b = $m[2];
    preg_match("/(.*)(\.\d+)/", $b, $m);
    $b = $m[1];
    $currenturl = $a.$b;

    if (substr($currenturl,-1) == "=") {$currenturl = substr($currenturl, 0, -6);}
  }

  if ($specialcase == 0 || $specialcase == 2){
    preg_match("/.*(\?)(.*)/", $currenturl, $m);
    $sqs = $m[2];
    if ($sqs == "") {
      $currenturl .= "?menu=".$submenu; 
    } else if (strpos($sqs, "menu=") !== FALSE) {
      $currenturl .= ".".$submenu; 
    } else {
      $currenturl .= "&menu=.".$submenu;
    }
  }

  $currenturl = str_replace("=.", "=", $currenturl);
  $text = $strdepth.LINKSTART."<a".$linkadd." href=\"".$currenturl."\">".$linkname."</a>".LINKEND."\n";  
  return $text;
}

function renderlink($alink_name, $alink_url, $alink_open, $alink_depth, $alink_menu)
{
  $text = "";
  $matches = preg_match("/submenu ([0-9]+)/i", $alink_url, $match);
  $strdepth = str_repeat("&nbsp", $alink_depth);

  if (!$matches) 
  {
    switch ($alink_open) {
      case 1:
        $link_append = " onclick=\"window.open('$alink_url'); return false;\"";
        break;
      case 2:
        $link_append = " target=\"_parent\"";
        break;
      case 3:
        $link_append = " target=\"_top\"";
        break;
      default:
        unset($link_append);
    }

    if(!eregi("http:", $alink_url)){ $alink_url = e_HTTP.$alink_url; }

    if($alink_open == 4){
      $text .=  $strdepth.LINKSTART."<a".$linkadd." href=\"javascript:openwindow('".$alink_url."')\">".$alink_name."</a>".LINKEND."\n";
    }else{  
      $text .=  $strdepth.LINKSTART."<a".$linkadd." href=\"".$alink_url."\"".$link_append.">".$alink_name."</a>".LINKEND."\n";
    }

  }else{
    $link_category = $match[1];

    if ($alink_menu == "") {
      $text .= makemenuurl($strdepth, $linkadd, $link_category, $alink_name, 0);
    }else{
      list($link_menu_now, $link_menu_sub) = explode(".", $alink_menu, 2); 

      if ($link_menu_now == $link_category) {
        $currenturl = $_SERVER["REQUEST_URI"];
        if (substr($currenturl,-1) == "=") {$currenturl = substr($currenturl, 0, -6);}     
 
        $text .= makemenuurl($strdepth, $linkadd, $link_category, $alink_name, 1);

        $sql = new db;
        $sql->db_Select("links", "*", "link_category='".$link_category."' ORDER BY link_order");
 
        while($row = $sql->db_Fetch())
        {
          extract($row);

          $text .= renderlink($link_name, $link_url, $link_open, ($alink_depth + 2), $link_menu_sub);
        }
      }else{
        /* $text .=  $strdepth.LINKSTART."<a".$linkadd." href=\"".$currenturl."\">".$alink_name."</a>".LINKEND."\n";*/
        $text .= makemenuurl($strdepth, $linkadd, $link_category, $alink_name, 2);
      }
    }
  }

  return $text;
}

unset($text);
$text = "";

$sql -> db_Select("links", "*", "link_category='1' ORDER BY link_order");

if(IsSet($_GET['menu'])){
  $link_menu_sub = $_GET['menu'];
} else {
  $link_menu_sub = "";
}

$text = PRELINK;
while($row = $sql->db_Fetch())
{
  extract($row);
  $link_depth = 0;
  $text .= renderlink($link_name, $link_url, $link_open, $link_depth, $link_menu_sub);
}
$text .= POSTLINK;

$ns -> tablerender(LAN_183, $text);

?>
